/***************************************************************************
 ***        Programm zur Ansteuerung der PC-Karte                        ***
 ***                    IO 1283                                          ***
 ***************************************************************************/

#include <stdio.h>           /* Prototypen fr Ein-Ausgabe */
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <string.h>

void clear_screen(void);

unsigned char key=0;
unsigned int  adresse=0x100;
unsigned int  Eingang,Ausgang;

/************************************************************************
 ***                Hauptprogramm                                     ***
 ************************************************************************/

void main(void)
{
  int i,k;
  char cx=0;

  /* Ausgaenge auf 0 setzen */
  outport(adresse,0);

  /* Bildschirm initialisieren */
  clear_screen();                       /* Bildschirm lschen           */
  _setcursortype(_NOCURSOR);

  /* Tasten auswerten */
  key=0;                                /* Variable fr Taste initialisieren */
  do                                    /* in Schleife verharren        */
    {                                   /* bis Taste           gedrckt */
      if(kbhit())                       /* Ist Taste gedrckt ?         */
	{                               /* Wenn ja, dann                */
	  key=getch();                  /* ASCII-Wert lesen             */
	  if(key==0)
	    {
	      /* Funktionstaste -> Scan-Code auswerten */
	      key=getch();              /* Scan-Code holen              */
	      switch (key)
		{
		  case 77 :
		    {
		      /* Cursor rechts */
		      if(cx>0)
			cx--;
		      else
			printf("\a");
		      break;
		    }
		  case 75 :
		    {
		      /* Cursor links */
		      if(cx<15)
			cx++;
		      else
			printf("\a");
		      break;
		    }
		}
	    }
	  else
	    {
	      /* Einfache Zeichentaste wurde bettigt */
	      switch(key)
		{
		  case 13 :    /* Taste Return/Enter */
		  case 32 :    /* Taste Space */
		    {
		      /* Ausgabebit invertieren auf der der Cursor steht*/
		      Ausgang=Ausgang ^ (1 << cx);
		      /* An Karte ausgeben */
		      outport(adresse,Ausgang);
		      break;
		    }
		}
	    }
	}
      /* Eingaenge lesen */
      Eingang=inport(adresse);
      /* Eingangswerte auf dem Bildschirm in der Tabelle darstellen */
      for(k=0;k<16;k++)      /* alle 16 Bit */
	{
	  textattr(0x7E);  /* Darstellung normaler Eintrag */
	  if((Eingang & (1 << k))==0)
	    {
	      gotoxy(63-(4*k),11);
	      cprintf(" 0 ");
	    }
	  else
	    {
	      gotoxy(63-(4*k),11);
	      cprintf(" 1 ");
	    }
	}
      /* Ausgangswerte auf dem Bildschirm in der Tabelle darstellen */
      for(k=0;k<16;k++)      /* alle 16 Bit */
	{
	  if(cx==k)
	    textattr(0x2A);  /* Darstellung Cursor */
	  else
	    textattr(0x7E);  /* Darstellung normaler Eintrag */
	  if((Ausgang & (1 << k))==0)
	    {
	      gotoxy(63-(4*k),13);
	      cprintf(" 0 ");
	    }
	  else
	    {
	      gotoxy(63-(4*k),13);
	      cprintf(" 1 ");
	    }
	}
    }
  while (key!=68);                      /* Wenn F10, dann ende          */
  textattr(0x07);
  clrscr();
  /* Ausgnge zurcksetzen */
  outport(adresse,0);
  _setcursortype(_NORMALCURSOR);        /* Standardcursor an            */
}

/************************************************************************
 ***                Unterprogramme zur Bildschirmsteuerung            ***
 ************************************************************************/

void clear_screen(void)
{
  /* Diese Funktion dient zum lschen des Bildschirmes, sowie dessen
	  Einstellung. Der Hintergrund wird auf die Farbe Blau eingestellt.
	  Es wird des weiteren ein Fenster mit der Firmenadresse dargestellt.  */

  /* Fenster 1 */
  char rahm1[]="ͻ";
  char rahm2[]="                                                         ";
  char rahm3[]="ͼ";
  char text1[]=" ERMA-Electronic GmbH, Max-Eyth-Str. 8, 78194 Immendingen";
  char text2[]="      Tel. 07462/7381               Fax 07462/7554       ";
  char text3[]="";

  /* Fenster 2 */
  char rahm21[]="ͻ";
  char rahm22[]="                                                                           ";
  char rahm23[]=" F10 = ENDE ͼ";
  char zeile1[]="Ŀ";
  char zeile2[]="Ĵ";
  char zeile3[]="";
  char zeile4[]="                                                         ";
  char text20[]=" 15  14  13  12  11  10   9   8   7   6   5   4   3   2   1   0   Bit";

  char x;

  textbackground(BLUE);                 /* Hintergrundfarbe schwarz     */
  textcolor(CYAN);                      /* Vordergrundfarbe hellgrau    */
  clrscr();                             /* Bildschirm lschen           */

  /* Erzeugen eines Fensters */
  gotoxy(12,2);
  textattr(0x7F);
  cprintf(rahm1);
  gotoxy(12,3);
  cprintf(rahm2);
  gotoxy(12,4);
  cprintf(rahm2);
  gotoxy(12,5);
  cprintf(rahm3);
  /* Erzeugen des Fenstertextes */
  textattr(0x70);
  gotoxy(13,3);
  cprintf(text1);
  gotoxy(13,4);
  cprintf(text2);
  /* Erzeugen des Fensterschattens */
  gotoxy(13,6);
  cprintf(text3);
  gotoxy(71,3);
  cprintf("");
  gotoxy(71,4);
  cprintf("");
  gotoxy(71,5);
  cprintf("");
  textattr(0x03);

  /* Erzeugen des Ausgabefensters */
  gotoxy(1,8);
  textattr(0x7F);
  cprintf(rahm21);
  for(x=9;x<17;x++)
    {
      gotoxy(1,x);
      cprintf(rahm22);
    }
  gotoxy(1,x++);
  cprintf(rahm23);
  /* Erzeugen des Fenstertextes */
  textattr(0x70);
  gotoxy(2,15);
  cprintf(text20);
  gotoxy(2,10);
  cprintf(zeile1);
  gotoxy(2,11);
  cprintf(zeile4);
  gotoxy(2,12);
  cprintf(zeile2);
  gotoxy(2,13);
  cprintf(zeile4);
  gotoxy(2,14);
  cprintf(zeile3);
  /* Konfiguration eintragen */
  gotoxy(68,11);
  textattr(0x74);
  cprintf("Eingang");
  gotoxy(68,13);
  textattr(0x7A);
  cprintf("Ausgang");
}

