#include <stdio.h>
#include <conio.h>
#include <dos.h>

#define IO_INT 10

#if IO_INT==5
  int INTNO=0x0D;
  int Mark=0x0DF;
#elif IO_INT==10
  int INTNO=0x72;
  int Mark=0x0FB;
#elif IO_INT==11
  int INTNO=0x73;
  int Mark=0x0F7;
#elif IO_INT==12
  int INTNO=0x74;
  int Mark=0x0EF;
#elif IO_INT==15
  int INTNO=0x77;
  int Mark=0x7F;
#else
#error Interrupt nicht verfuegbar !!
#endif

unsigned int Adresse=0x100;
volatile unsigned int Flag=0;
unsigned int Mask;
volatile unsigned int Wert;
volatile unsigned int test[80];
int x;
void interrupt (*AlterInterrupt)();
void clear_screen(void);

/********************************************************************
 *** Interruptroutine                                             ***
 ********************************************************************/
void interrupt Eingang(void)
{
  /* Wert einlesen */
  Wert = inport(Adresse);
  /* Wert in Puffer eintragen (damit keine Werte verlorengehen!) */
  test[Flag]=Wert;
  /* Pufferzeiger (gleichzeitig Flag fr eingetroffene IRQ's) erhhen */
  Flag++;
  /* Eingelesener Wert wird fr Testzwecke sofort an die Ausgnge
     weitergegeben */
  outport(Adresse,Wert);
  /* zurcksetzen der Interruptcontroller des PC's */
#if IO_INT!=5
  outportb(0x0A0,0x20);
#endif

  outportb(0x20,0x20);
  /* Alte Interruptfunktion aufrufen */
  AlterInterrupt();
}

/********************************************************************
 *** Hauptprogramm                                                ***
 ********************************************************************/
void main(void)
{
  /* Wert lesen (nimmt ev. vorh. IRQ der Karte zurck) */
  test[0] = inport(Adresse);
  Flag=1;
  /* Ausgnge in Ausgangsporition */
  outport(Adresse,0);
  /* Alten Interruptvektor sichern */
  AlterInterrupt = getvect(INTNO);
  /* Neuen Interruptvektor setzen */
  setvect(INTNO,Eingang);
  /* Interruptcontroller fr gewhlten IRQ freigeben */
#if IO_INT==5
  Mask=inportb(0x21);
  outportb(0x21,(Mask & Mark));
#else
  Mask=inportb(0x0A1);
  outportb(0x0A1,(Mask & Mark));
  outportb(0x0A0,0x20);
#endif
  /* Interruptcontroller zurcksetzen */
  outportb(0x20,0x20);

  _setcursortype(_NOCURSOR);
  clear_screen();
  do
	 {
	  /* Sind bereits IRQ's eingetroffen? */
	  if (Flag >= 1)
	    {
	      /* Eingangswerte auf dem Bildschirm in der Tabelle darstellen */
	      for(x=0;x<16;x++)      /* alle 16 Bit */
		{
		  textattr(0x7E);  /* Darstellung normaler Eintrag */
		  if((test[Flag-1] & (1 << x))==0)
		    {
		      gotoxy(63-(4*x),11);
		      cprintf(" 0 ");
		    }
		  else
		    {
		      gotoxy(63-(4*x),11);
		      cprintf(" 1 ");
		    }
		}
	      Flag=0;
	    }
	 }
  while(!kbhit());
  getch();
  /* Ausgnge zurcksetzen */
  outport(Adresse,0x0);
  /* Interruptcontroller rcksetzen */
#if IO_INT==5
  outportb(0x21,Mask);
#else
  outportb(0x0A1,Mask);
#endif
  /* Alten Interruptvektor setzen */
  setvect(INTNO,AlterInterrupt);
  _setcursortype(_NORMALCURSOR);
}

/************************************************************************
 ***                Unterprogramme zur Bildschirmsteuerung            ***
 ************************************************************************/

void clear_screen(void)
{
  /* Diese Funktion dient zum lschen des Bildschirmes, sowie dessen
	  Einstellung. Der Hintergrund wird auf die Farbe Blau eingestellt.
	  Es wird des weiteren ein Fenster mit der Firmenadresse dargestellt.  */

  /* Fenster 1 */
  char rahm1[]="ͻ";
  char rahm2[]="                                                         ";
  char rahm3[]="ͼ";
  char text1[]=" ERMA-Electronic GmbH, Max-Eyth-Str. 8, 78194 Immendingen";
  char text2[]="      Tel. 07462/7381               Fax 07462/7554       ";
  char text3[]="";

  /* Fenster 2 */
  char rahm21[]="ͻ";
  char rahm22[]="                                                                           ";
  char rahm23[]=" Taste = ENDE ͼ";
  char zeile1[]="Ŀ";
  char zeile2[]="";
  char zeile3[]="                                                         ";
  char text20[]=" 15  14  13  12  11  10   9   8   7   6   5   4   3   2   1   0   Bit";
  char text21[]="Bei einem Interrupt werden Ein- und Ausgnge sofort aktualisiert!";

  char x;

  textbackground(BLUE);                 /* Hintergrundfarbe schwarz     */
  textcolor(CYAN);                      /* Vordergrundfarbe hellgrau    */
  clrscr();                             /* Bildschirm lschen           */

  /* Erzeugen eines Fensters */
  gotoxy(12,2);
  textattr(0x7F);
  cprintf(rahm1);
  gotoxy(12,3);
  cprintf(rahm2);
  gotoxy(12,4);
  cprintf(rahm2);
  gotoxy(12,5);
  cprintf(rahm3);
  /* Erzeugen des Fenstertextes */
  textattr(0x70);
  gotoxy(13,3);
  cprintf(text1);
  gotoxy(13,4);
  cprintf(text2);
  /* Erzeugen des Fensterschattens */
  gotoxy(13,6);
  cprintf(text3);
  gotoxy(71,3);
  cprintf("");
  gotoxy(71,4);
  cprintf("");
  gotoxy(71,5);
  cprintf("");
  textattr(0x03);

  /* Erzeugen des Ausgabefensters */
  gotoxy(1,8);
  textattr(0x7F);
  cprintf(rahm21);
  for(x=9;x<17;x++)
    {
      gotoxy(1,x);
      cprintf(rahm22);
    }
  gotoxy(1,x++);
  cprintf(rahm23);
  /* Erzeugen des Fenstertextes */
  textattr(0x70);
  gotoxy(2,13);
  cprintf(text20);
  gotoxy(5,15);
  cprintf(text21);
  gotoxy(2,10);
  cprintf(zeile1);
  gotoxy(2,12);
  cprintf(zeile2);
  gotoxy(2,11);
  cprintf(zeile3);
  /* Konfiguration eintragen */
  gotoxy(68,11);
  textattr(0x74);
  cprintf("Eingang");
}

