{***************************************************************************
 ***        Programm zur Ansteuerung der PC-Karte                        ***
 ***                    IO 1283                                          ***
 ***************************************************************************}

uses Crt,Dos;

var
  key     : char ;
  adresse : Integer;
  Eingang : Integer;
  Ausgang : Integer;
  i,k     : Integer;
  cx      : Byte;


{****************************************************************************
 *** Funktion zur An- und Abschaltung des Cursors                         ***
 *** bergabeparameter: sichtbar = false => Cursor wird abgeschaltet      ***
 ***                    sichtbar = true  => Cursor wird angeschaltet      ***
 ****************************************************************************}
PROCEDURE cursor(sichtbar: boolean);
VAR
	reg 			: registers;
	schirmanfang	: longint;

BEGIN
	reg.ah:=1;
	if sichtbar then begin
    	if schirmanfang=$b800 then begin
       		reg.ch:=6;
       		reg.cl:=7;
      	end
     	else begin
       		reg.ch:=12;
       		reg.cl:=13;
      	end;
    	INTR(16,reg);
	end
	else begin
		reg.ch:=32;
    	reg.cl:=7;
    	INTR(16,reg);
	end;
end;

{************************************************************************
 ***                Unterprogramme zur Bildschirmsteuerung            ***
 ************************************************************************}

procedure clear_screen;
  { Diese Funktion dient zum lschen des Bildschirmes, sowie dessen
	  Einstellung. Der Hintergrund wird auf die Farbe Blau eingestellt.
	  Es wird des weiteren ein Fenster mit der Firmenadresse dargestellt.  }

  { Fenster 1 }
const
  rahm1:String='ͻ';
  rahm2:String='                                                         ';
  rahm3:String='ͼ';
  text1:String=' ERMA-Electronic GmbH, Max-Eyth-Str. 8, 78194 Immendingen';
  text2:String='      Tel. 07462/7381               Fax 07462/7554       ';
  text3:String='';

  { Fenster 2 }
  rahm21:String='ͻ';
  rahm22:String='                                                                           ';
  rahm23:String=' F10 = ENDE ͼ';
  zeile1:String='Ŀ';
  zeile2:String='Ĵ';
  zeile3:String='';
  zeile4:String='                                                         ';
  text20:String=' 15  14  13  12  11  10   9   8   7   6   5   4   3   2   1   0   Bit';

var
  x : Byte;

begin
  textbackground(BLUE);                 { Hintergrundfarbe schwarz     }
  textcolor(CYAN);                      { Vordergrundfarbe hellgrau    }
  clrscr;                               { Bildschirm lschen           }

  { Erzeugen eines Fensters }
  gotoxy(12,2);
  textattr:=$7F;
  Write(rahm1);
  gotoxy(12,3);
  Write(rahm2);
  gotoxy(12,4);
  Write(rahm2);
  gotoxy(12,5);
  Write(rahm3);
  { Erzeugen des Fenstertextes }
  textattr:=$70;
  gotoxy(13,3);
  Write(text1);
  gotoxy(13,4);
  Write(text2);
  { Erzeugen des Fensterschattens }
  gotoxy(13,6);
  Write(text3);
  gotoxy(71,3);
  Write('');
  gotoxy(71,4);
  Write('');
  gotoxy(71,5);
  Write('');
  textattr:=$03;

  { Erzeugen des Ausgabefensters }
  gotoxy(1,8);
  textattr:=$7F;
  Write(rahm21);
  for x:=9 to 17 do
    begin
    gotoxy(1,x);
    Write(rahm22);
    end;
  Inc(x);
  gotoxy(1,x);
  Write(rahm23);
  { Erzeugen des Fenstertextes }
  textattr:=$70;
  gotoxy(2,15);
  Write(text20);
  gotoxy(2,10);
  Write(zeile1);
  gotoxy(2,11);
  Write(zeile4);
  gotoxy(2,12);
  Write(zeile2);
  gotoxy(2,13);
  Write(zeile4);
  gotoxy(2,14);
  Write(zeile3);
  { Konfiguration eintragen }
  gotoxy(68,11);
  textattr:=$74;
  Write('Eingang');
  gotoxy(68,13);
  textattr:=$7A;
  Write('Ausgang');
end;

{************************************************************************
 ***                Hauptprogramm                                     ***
 ************************************************************************}

begin

  cx:=0;
  adresse:=$100;
  { Ausgaenge auf 0 setzen }
  PortW[adresse]:=0;

  { Bildschirm initialisieren }
  clear_screen;                         { Bildschirm lschen           }
  cursor(false);

  { Tasten auswerten }
  key:=Chr(0);                          { Variable fr Taste initialisieren }
  repeat                                { in Schleife verharren        }
                                        { bis Taste gedrckt }
      if keypressed then                { Ist Taste gedrckt ?         }
	begin                           { Wenn ja, dann                }
	  key:=readkey;                 { ASCII-Wert lesen             }
	  if key=Chr(0) then
            begin
	      { Funktionstaste -> Scan-Code auswerten }
	      key:=readkey;             { Scan-Code holen              }
	      case Ord(key) of
		77 :begin
		    { Cursor rechts }
		    if cx>0 then
		      Dec(cx)
		    else
                      begin
                      sound(1000);
                      delay(100);
                      nosound;
                      end;
		    end;
		75 :begin
		    { Cursor links }
		    if cx<15 then
		      Inc(cx)
		    else
                      begin
                      sound(1000);
                      delay(100);
                      nosound;
                      end;
                    end;
               end;
	    end
	  else
	    begin
	      { Einfache Zeichentaste wurde bettigt }
	      case Ord(key) of
		13 ,    { Taste Return/Enter }
		32 :    { Taste Space }
                    begin
		      { Ausgabebit invertieren auf der der Cursor steht}
		      Ausgang:=Ausgang xor (1 shl cx);
		      { An Karte ausgeben }
		      PortW[adresse]:=Ausgang;
		    end;
              end;
	    end;
	end;
      { Eingaenge lesen }
      Eingang:=PortW[adresse];
      { Eingangswerte auf dem Bildschirm in der Tabelle darstellen }
      for k:=0 to 15 do      { alle 16 Bit }
	begin
	  textattr:=$7E;     { Darstellung normaler Eintrag }
	  if ((Eingang and (1 shl k))=0) then
	    begin
	      gotoxy(63-(4*k),11);
	      Write(' 0 ');
	    end
	  else
	    begin
	      gotoxy(63-(4*k),11);
	      Write(' 1 ');
	    end;
	end;
      { Ausgangswerte auf dem Bildschirm in der Tabelle darstellen }
      for k:=0 to 15 do      { alle 16 Bit }
	begin
	  if cx=k then
	    textattr:=$2A    { Darstellung Cursor }
	  else
	    textattr:=$7E;   { Darstellung normaler Eintrag }
	  if ((Ausgang and (1 shl k))=0) then
	    begin
	      gotoxy(63-(4*k),13);
	      Write(' 0 ');
	    end
	  else
	    begin
	      gotoxy(63-(4*k),13);
	      Write(' 1 ');
	    end;
	end;
  until Ord(key)=68;                    { Wenn F10, dann ende          }
  cursor(true);
  textattr:=$07;
  clrscr;
  { Ausgnge zurcksetzen }
  PortW[adresse]:=0;
end.

